#!/usr/bin/perl
#
#
# This module assists in color handling.
# 		this module is written by ...: geronimo at vdrportal dot de
# 
# COPYRIGHT:	(c) 2005 Creative Commons by-nc-sa
#					some rights reserved. For details on copyright see:
#					http://creativecommons.org/licenses/by-nc-sa
#
# DISCLAIMER:	NO WARANTY AT ALL. Use at your own risk.
#
# vi: ts=3
#		
# DESCRIPTION: see README on a detailled description
#
package V2I::colorSelection;
#use strict;
use Tk;
use Data::Dumper;
use v2icfg;

BEGIN {
	use Exporter   ();
	our ($VERSION, @ISA, @EXPORT, @EXPORT_OK, %EXPORT_TAGS);
	$VERSION     = "&vdr2iso-version;";
	@ISA         = qw(Exporter);
	@EXPORT      = qw(&selectColor &hexColor &colorByNameOrValue $config
						   $mw $debug %colorTable);
	%EXPORT_TAGS = ( );
	@EXPORT_OK   = qw( );
}

our $mw;
our $config;
my $colorDialog;

sub hexColor {
	my $color = shift;
	print('hexColor: '.Dumper($color)."\n") if $debug;
	my $rv = '#';
	my @hex = ('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F');
	
	foreach my $part (@$color){
		my $high = sprintf("%d", $part / 16);
		my $low  = sprintf("%d", $part % 16);
		$rv .= $hex[$high].$hex[$low];
		}
	print('hexColor created '.$rv."\n") if $debug;	
	return $rv;	
}

sub colorByNameOrValue{
	my $colName = uc(shift);
	my $red   = 0;
	my $green = 0;
	my $blue  = 0;

	print('colorByNameOrValue: <'.$colName.">\n") if $debug;
	if($colName =~ /^0X/ or $colName =~ /^#/){
		$colName =~ s/^0X//;
		$colName =~ s/^#//;
		print('color seems to be hex-value: '.$colName."\n") if $debug;
		$red	 = hex(substr($colName,0,2));
		$green = hex(substr($colName,2,2));
		$blue  = hex(substr($colName,4,2));
		}
	elsif($colName =~ /(\d+),(\d+),(\d+)/){
		$red   = $1;
		$green = $2;
		$blue  = $3;
		}
	else{
		my $color = $colorTable{byName}{$colName};
		$red	 = $$color[0];
		$green = $$color[1];
		$blue  = $$color[2];
		}
	print('colorByNameOrValue: result=('.$red.','.$green.','.$blue.")\n") if $debug;
	return [$red,$green,$blue];
}

sub setColor {
	my $lbl = shift;
	my $cn = shift;
	my $lblColor = shift;
	my $scales = shift;
	my $colors = colorByNameOrValue($cn);

	$$scales[0]->set($colors->[0]);
	$$scales[1]->set($colors->[1]);
	$$scales[2]->set($colors->[2]);
}

sub chgColor {
	my $cp = shift;
	my $lbl = shift;
	my $red = shift;
	my $green = shift;
	my $blue = shift;
	my $color = hexColor([$$red, $$green, $$blue]);
	my $cn = $color;
	
	$cn = $colorTable{byValue}{$color} if "$colorTable{byValue}{$color}";
	$$lbl->configure(-background=>$color, -text=>$cn);
}

sub csExit {
	my $ec = shift;

	if($ec =~ /^Ok$/){
		my $lbl   = shift;	  
		my $var   = shift;
		my $red   = shift;
		my $green = shift;
		my $blue  = shift;
		my $colValue = hexColor([$$red, $$green, $$blue]);
		my $colName  = $colValue;
		
		$colName = $colorTable{byValue}{$colValue} if "$colorTable{byValue}{$colValue}";

		$$var = $colName;
		$lbl->configure(-background=>$colValue, -text=>$colName);
		}
	$colorSelectionWindow->withdraw();
	$colorSelectionWindow = 0;
}
		  
sub selectColor {
	my $xLabel = shift;
	my $colVar = shift;

	if($colorSelectionWindow and Exists($colorSelectionWindow)){
		$colorSelectionWindow->deiconify();
		$colorSelectionWindow->raise();
		}
	else{
		print('colorSelection: varColor=<'.${$colVar}.">\n") if $debug;
		my $colors = colorByNameOrValue(${$colVar});
		my $redPart   = $$colors[0];
		my $greenPart = $$colors[1];
		my $bluePart  = $$colors[2];
	   my $d = $mw->Toplevel();
		$d->title($appText{$appLang}{colorSelection});
		$d->minsize(300,600);

		print('colors: ('.$redPart.','.$greenPart.','.$bluePart.")\n") if $debug;
		$colorSelectionWindow = $d;
		my $f = $d->Frame()->pack(-side=>'bottom');
		$f->Button(-text=>$appText{$appLang}{ok},     -command=>[\&csExit, 'Ok', $xLabel, $colVar, \$redPart, \$greenPart, \$bluePart])->pack(-side=>'left');
		$f->Button(-text=>$appText{$appLang}{cancel}, -command=>[\&csExit, 'Cancel'])->pack(-side=>'left');

		my $t  = $d->Scrolled('Text', -width=>30, -scrollbars=>'ose', -wrap=>'none')->pack(-side=>'left', -expand=>1, -fill=>'both');
		my $xf = $d->Frame->pack(-side=>'right', -expand=>1, -fill=>'both');
		my $lColor = $xf->Label(-relief=>'groove')->pack(-expand=>1, -anchor=>'n', -fill=>'both');
		my $scales = [ $xf->Scale(-from=>0, -to=>255, -command=>[\&chgColor, 'r', \$lColor, \$redPart, \$greenPart, \$bluePart], -variable=>\$redPart, -length=>200, -sliderlength=>6, -label=>'red')->pack(-side=>'left', -anchor=>'s'),
							$xf->Scale(-from=>0, -to=>255, -command=>[\&chgColor, 'g', \$lColor, \$redPart, \$greenPart, \$bluePart], -variable=>\$greenPart, -length=>200, -sliderlength=>6, -label=>'green')->pack(-side=>'left', -anchor=>'s'),
							$xf->Scale(-from=>0, -to=>255, -command=>[\&chgColor, 'b', \$lColor, \$redPart, \$greenPart, \$bluePart], -variable=>\$bluePart, -length=>200, -sliderlength=>6, -label=>'blue')->pack(-side=>'left', -anchor=>'s') ];

		foreach my $color (@main::colors){		  
			my $colVal = hexColor(colorByNameOrValue($color));	  
			my $w = $t->Label(-text=>$color, -background=>$colVal,-relief=>'groove', -width=>30);

			$t->windowCreate('end', -window=>$w);
			$t->insert('end', "\n");
			$w->bind('<Button-1>', [\&setColor, $color, \$lColor, $scales]);
			}
		$t->configure(-state=>'disabled');
		}
}

END {}

1;
