#!/usr/bin/perl
#
#
# This module assists in creation and modification of images needed to build
# a dvd menu.
# 		this module is written by ...: geronimo at vdrportal dot de
# 
# COPYRIGHT:	(c) 2005 Creative Commons by-nc-sa
#					some rights reserved. For details on copyright see:
#					http://creativecommons.org/licenses/by-nc-sa
#
# DISCLAIMER:	NO WARANTY AT ALL. Use at your own risk.
#
# vi: ts=3
#		
# DESCRIPTION: see README on a detailled description
#
#
package V2I::dvdMenu;
use GD;
use Tk;
use Tk::PNG;
use Data::Dumper;
use File::Basename;
use V2I::colorSelection;
use v2icfg;

BEGIN {
	use Exporter   ();
	our ($VERSION, @ISA, @EXPORT, @EXPORT_OK, %EXPORT_TAGS);
	$VERSION     = "&vdr2iso-version;";
	@ISA         = qw(Exporter);
	@EXPORT      = qw(&createMenus &dvdMenuPreview);
	%EXPORT_TAGS = ( );
	@EXPORT_OK   = qw( );
}

sub max {
	my $a = shift;
	my $b = shift;
	my $c = shift;
	my $rv = $a;

	$rv = $b if $b > $a;
	$rv = $c if $c > $rv;
	return $rv;
}

sub min {
	my $a = shift;
	my $b = shift;
	my $rv = $a;
	
	$rv = $b if $b < $a;
	return $rv;
}

sub dvdMenuPreview {
	my $fn = shift;

	if($main::dvdMenuPreviewWindow and Exists($main::dvdMenuPreviewWindow)){
		$main::dvdMenuPreviewWindow->deiconify();
		$main::dvdMenuPreviewWindow->raise();
		
		my @kids = $main::dvdMenuPreviewWindow->children();
		foreach my $w (@kids){
			$w->destroy();	  
			}
		}
	else{
		my $w = $mw->Toplevel();	  
		$w->title($appText{$appLang}{dvdMenuPreview});
		$main::dvdMenuPreviewWindow = $w;
		}
	my $c = $main::dvdMenuPreviewWindow->Canvas(-height=>576, -width=>720
														   , -scrollregion=>[0,0,720,576]
															, -cursor=>'crosshair'
													 		 )->pack(-side=>'left', -fill=>'both', -expand=>1);
	my $img = $main::dvdMenuPreviewWindow->Photo(-format=>'png', -file=>$fn);					 
	$c->createImage(720, 576, -image=>$img, -anchor=>'se');
}

sub createBackground {
	my $job = shift;

	my	$settings  = $job->{'settings'}->{'item'};
	my $header    = $settings->{'header'}->{'value'};
	my $imgName   = checkImage($settings->{'imgBack'}->{'value'});
	my $imgSrc    = GD::Image->new($imgName);
	my $image     = new GD::Image(720, 576);
	my $sHeight   = 535;
	
	$sHeight = 505 if($settings->{'aspect'}->{'value'} =~ /^lb$/);
	if($imgSrc->width < 720 and $imgSrc->height < $sHeight){
		my $colBackground = colorByNameOrValue($settings->{'colBack'}->{'value'});

		my $mBack = $image->colorResolve($colBackground->[0],$colBackground->[1],$colBackground->[2]);
		$image->fill(0,0,$mBack);
		$image->copy($imgSrc, 720 - $imgSrc->width, $sHeight - $imgSrc->height, 0, 0, $imgSrc->width, $imgSrc->height);	  
		}
	else{ $image->copyResampled($imgSrc, 0, 0, 0, 0, 720, 576, $imgSrc->width, $imgSrc->height); }			  
	my $colShadow = colorByNameOrValue($settings->{'colShadow'}->{'value'});
	my $colFront  = colorByNameOrValue($settings->{'colFront'}->{'value'});
	my $mShadow   = $image->colorResolve($colShadow->[0], $colShadow->[1], $colShadow->[2]);
	my $mFront    = $image->colorResolve($colFront->[0], $colFront->[1], $colFront->[2]);
	my $mWhite    = $image->colorResolve(255,255,255);       
	my $imgShadow = new GD::Image(720, 576);

	$imgShadow->trueColor(1);
   my $dummy = $imgShadow->colorResolve($colShadow->[0], $colShadow->[1], $colShadow->[2]);
	$imgShadow->fill(0,0,$dummy);

	$image->setThickness(2);
	my $size = $settings->{'fntBig'}->{'size'};
	my $soff = sprintf("%d", $size / 20);

	if($settings->{'aspect'}->{'value'} =~ /^lb$/){
	   $image->copyMerge($imgShadow, 65,  92, 0, 0, 622,  54, 40);
	   $image->copyMerge($imgShadow, 65, 158, 0, 0, 493, 302, 40);
	   $image->rectangle( 50,  84, 680, 141, $mFront);
	   $image->rectangle( 50, 150, 550, 454, $mFront);
#	   $image->rectangle(560, 148, 690, 465, $mWhite);
	   $image->clip(     560, 148, 690, 465);
	   $image->stringFT($mShadow, $settings->{'fntBig'}->{'value'}, $size, 1.575, 684 + $soff +1, 462 + $soff, $header);
	   $image->stringFT($mFront, $settings->{'fntBig'}->{'value'}, $size, 1.575, 684, 462, $header);
		}
   elsif($main::combat){		  
	   $image->copyMerge($imgShadow, 76,  42, 0, 0, 587,  56, 40);
	   $image->copyMerge($imgShadow, 76, 109, 0, 0, 466, 360, 40);
	   $image->rectangle( 70,  34, 656,  93, $mFront);
	   $image->rectangle( 70, 101, 534, 464, $mFront);
#	   $image->rectangle(546, 101, 690, 473, $mWhite);
	   $image->clip(     546, 101, 690, 473);
	   $image->stringFT($mShadow, $settings->{'fntBig'}->{'value'}, $size, 1.575, 674 + $soff +1, 468 + $soff, $header);
	   $image->stringFT($mFront, $settings->{'fntBig'}->{'value'}, $size, 1.575, 674, 468, $header);
		}
   else{		  
	   $image->copyMerge($imgShadow, 65,  42, 0, 0, 622,  54, 40);
	   $image->copyMerge($imgShadow, 65, 108, 0, 0, 493, 383, 40);
	   $image->rectangle( 50,  34, 680,  91, $mFront);
	   $image->rectangle( 50, 100, 550, 485, $mFront);
#	   $image->rectangle(560, 100, 690, 495, $mWhite);
	   $image->clip(     560, 100, 690, 495);
	   $image->stringFT($mShadow, $settings->{'fntBig'}->{'value'}, $size, 1.575, 684 + $soff +1, 493 + $soff, $header);
	   $image->stringFT($mFront, $settings->{'fntBig'}->{'value'}, $size, 1.575, 684, 493, $header);
		}
	$image->clip(0, 0, $image->width, $image->height);

	if($main::testOnly){
		my $fp;
		if(open($fp, '> '.$job->{'title'}.'-0.png')){
			binmode($fp);
			print($fp $image->png);
			close($fp);
			}
		}
	return $image;
}

sub checkImage {
	my $usrName = shift;
	my $rv = $usrName;
	die('Oups, missing image filename :('."\n") if not "$usrName";
	my $rawName = basename($usrName);
	my $name = $rawName;
	my $xt   = '';
	
	if($rawName =~ /(.+?)\.([^\.]+)$/){
		$name = $1;
		$xt   = $2;
		}
	if(not $xt =~ /^png$/i){
		my $target = $work;

		$target .= '/' if not $target =~ /\/$/;
		$target .= $name.'.png';

		my $cmd = 'convert \''.$usrName.'\' \''.$target.'\'';
		system($cmd);
		$rv = $target if(-s $target);
		}
	return $rv;	
}

sub writeSummary(\$$$$$$$$) {
	my $image = shift;
	my $text  = shift;
	my $settings = shift;
	my $fntSize = shift;
	my $x1 = shift;
	my $y1 = shift;
	my $x2 = shift;
	my $y2 = shift;
	my $white = $$image->colorResolve(255,255,255);

#	$$image->rectangle($x1, $y1, $x2, $y2, $white);
	my @words = split(/\s/, $text);
	push(@words, $text) if not $#words;
	push(@words, ' ');
	my(@bounds,$width,$height,$next);
	my $mx = sprintf("%d", ($y2 - $y1) / ($fntSize + 5));
	
	for my $i (1 .. $mx){
		my $scratch = '';
		while(1){
			$next = shift(@words);	  
			last if(not "$next");
			@bounds = GD::Image->stringFT($white, $settings->{'fntStd'}{'value'}, $fntSize, 0, 0,0, $scratch.' '.$next);
			$width  = $x2 - $x1;
			$height = $y2 - $y1;
			if($#bounds){
				$width  = $bounds[2] - $bounds[0];
				$height = $bounds[1] - $bounds[7];		  
				}
		   if($width <= ($x2 - $x1)){ 
				$scratch .= ' '.$next; 
				}
			else{ 
			   unshift(@words, $next); 
				}
			last if(($width >= ($x2 - $x1)) or ($height >= ($y2 - $y1)));
			}
		$$image->stringFT($white, $settings->{'fntStd'}{'value'}, $fntSize, 0, $x1-5, $y1 -4 + $i * ($fntSize +5), $scratch);
		unshift(@words, $next) if "$scratch" and not "$next";
		}
}

sub drawButton(\$$$$) {
	my $image = shift;
	my $x = shift;
	my $y = shift;
	my $color = colorByNameOrValue(shift);
	my $red   = $color->[0];
	my $green = $color->[1];
	my $blue  = $color->[2];
	my $diff = max(255-$red, 255-$green, 255-$blue);
	my $bright = $$image->colorResolve(200,200,200);

	$$image->filledEllipse($x +2, $y +1, 30, 30, $bright);	  
	if($diff > 50){
		print('drawButton: bright button #'.$diff.' at ('.$x.'/'.$y.') with colBase=('.$red.','.$green.','.$blue.")\n") if $main::debug;	  
		for my $i (0 .. 1){
			my $color = $$image->colorResolve(min(255,$red  +$i*16)
								 						,min(255,$green+$i*16)
														,min(255,$blue +$i*16));
			$$image->filledEllipse($x - $i, $y - $i, 30 - 10*$i, 30 - 10*$i, $color);
			}
		}
	else{
		print('drawButton: dark button #'.$diff.' at ('.$x.'/'.$y.') with colBase=('.$red.','.$green.','.$blue.")\n") if $main::debug;	  
		for my $i (0 .. 1){
			my $color = $$image->colorResolve(max(0,0,$red  - (1-$i)*16)
								 						,min(0,0,$green- (1-$i)*16)
														,min(0,0,$blue - (1-$i)*16));
			$$image->filledEllipse($x - $i, $y - $i, 30 - 10*$i, 30 - 10*$i, $color);
			}
		}
}

sub createMenus {
   my $job = shift;
	my $work = shift;
	my	$settings = $job->{'settings'}->{'item'};
	my $yTop = 75;
	my $yBot = 527;
	if($settings->{'aspect'}->{'value'} =~ /^lb$/){
		$yTop = 125;
		$yBot = 497;
		}
	my $fp;
	my $colShadow = colorByNameOrValue($settings->{'colShadow'}->{'value'}); 
	my $red   = $colShadow->[0];
	my $green = $colShadow->[1];
	my $blue  = $colShadow->[2];
	my $colFront = colorByNameOrValue($settings->{'colFront'}->{'value'});

	my $imgBase = createBackground($job);
	my $imgMain = $imgBase->clone();
	my $mFront  = $imgMain->colorResolve($colFront->[0], $colFront->[1], $colFront->[2]);
	my $mShadow = $imgMain->colorResolve($red, $green, $blue);
	my $mWhite  = $imgMain->colorResolve(255,255,255);
	my $imgMBt  = new GD::Image(720, 576);
	my $dummy   = $imgMBt->colorResolve(0,0,0);
	my $imgEmpty = new GD::Image(720, 576);
	my $fntSize = $settings->{'fntStd'}->{'size'};

	$imgEmpty->trueColor(1);
	$imgEmpty->transparent($imgEmpty->colorAllocate(0,0,0));
	$imgMain->clip(0,0,$imgMain->width, $imgMain->height);
   $imgMain->stringFT($mFront, $settings->{'fntStd'}->{'value'}, 30, 0,  70, $yTop+1, $job->{'title'});
   $imgMain->stringFT($mShadow, $settings->{'fntStd'}->{'value'}, 30, 0,  68, $yTop, $job->{'title'});
	$imgMain->clip(8, $yTop, 550, $yBot - 42);

	$imgMBt->trueColor(1);
	$imgMBt->transparent($dummy);

	my @bounds = GD::Image->stringFT(0, $settings->{'fntStd'}->{'value'}
						 						 , $fntSize, 0, 0, 0, 'yT');
	my @bkBnds = GD::Image->stringFT(0, $settings->{'fntStd'}->{'value'}
						 						 , 30, 0, 0, 0, $appText{$appLang}{back});
	my $height = $bounds[1] - $bounds[5];
	my $wBack  = $bkBnds[4] - $bkBnds[0];
	my $i=0;

	print('width of Back-Button-String: '.$wBack."\n");
	foreach my $rec (@{$job->{'recordlist'}->{'recording'}}){
		my $dest     = $work.'/VDRSYNC.'.$i;
		my $image    = $imgBase->clone();
		my $buttons  = new GD::Image(720, 576);
		my $white    = $image->colorResolve(255,255,255);
		my $shadow   = $image->colorResolve($red, $green, $blue);
		my $front    = $image->colorResolve($colFront->[0], $colFront->[1], $colFront->[2]);

		$front = $shadow if $front eq $white;
		$buttons->trueColor(1);
		$buttons->transparent($buttons->colorAllocate(0,0,0));

		print('------------------------------------------------------------------------------'."\n");
		print('--- create menues for ['.$rec->{'title'}.']...'."\n");
		print('------------------------------------------------------------------------------'."\n");
	   $image->stringFT($front, $settings->{'fntStd'}->{'value'}, 32, 0,  70, $yTop+1, $appText{$appLang}{description});
	   $image->stringFT($white, $settings->{'fntStd'}->{'value'}, 32, 0,  68, $yTop  , $appText{$appLang}{description});

	   $image->stringFT($shadow, $settings->{'fntStd'}->{'value'}, 30, 0,  92, $yBot+1, $appText{$appLang}{playMovie});
	   $image->stringFT($white , $settings->{'fntStd'}->{'value'}, 30, 0,  90, $yBot  , $appText{$appLang}{playMovie});
	   $image->stringFT($shadow, $settings->{'fntStd'}->{'value'}, 30, 0, 650 - $wBack, $yBot+1, $appText{$appLang}{back});
	   $image->stringFT($white , $settings->{'fntStd'}->{'value'}, 30, 0, 648 - $wBack, $yBot, $appText{$appLang}{back});
		print('gonna write summary ...'."\n");
		writeSummary($image, $rec->{'summary'}, $settings, 15, 66, $yTop + 33, 555, $yBot - 35) if not $main::combat;
		writeSummary($image, $rec->{'summary'}, $settings, 15, 79, 108, 537, 475) if $main::combat;
		
		drawButton($buttons,  60, $yBot-14, $settings->{'colShadow'}->{'value'});
		drawButton($buttons, 670, $yBot-14, $settings->{'colShadow'}->{'value'});
		drawButton($image,  60, $yBot-14, $settings->{'colShadow'}->{'value'}) if $main::testOnly;
		drawButton($image, 670, $yBot-14, $settings->{'colShadow'}->{'value'}) if $main::testOnly;
		
		$imgMain->stringFT($mWhite, $settings->{'fntStd'}->{'value'}, $fntSize, 0, 100, $yTop + 63 + $i *2 * $height, $rec->{'title'});
		$imgMain->stringFT($mWhite, $settings->{'fntStd'}->{'value'}, 11, 0, 415, $yTop + 80 + $i *2 * $height, main::localizeTS($rec->{'ts'}));
	   drawButton($imgMain, 75, $yTop + 48 + $i *2 * $height, $settings->{'colShadow'}->{'value'}) if $main::testOnly; 
	   drawButton($imgMBt , 75, $yTop + 48 + $i *2 * $height, $settings->{'colShadow'}->{'value'}); 

		if(open($fp, '> '.$dest.'/menu-bg.png')){
			binmode($fp);
			print($fp $image->png);
			close($fp);
			}
		if(open($fp, '> '.$dest.'/menu-buttons.png')){
			binmode($fp);
			print($fp $buttons->png);
			close($fp);
			}
		if(open($fp, '> '.$dest.'/menu-no-buttons.png')){
			binmode($fp);
			print($fp $imgEmpty->png);
			close($fp);
			}
		if(open($fp, '> '.$dest.'/menu.xml')){
			print $fp '<subpictures><stream><spu force="yes" start="00:00:00.00"'."\n";
			print $fp 'image="'.$dest.'/menu-no-buttons.png"'."\n";
			print $fp 'select="'.$dest.'/menu-no-buttons.png"'."\n";
			print $fp 'highlight="'.$dest.'/menu-buttons.png" autooutline="infer" outlinewidth="5"'."\n";
			print $fp 'autoorder="rows"/></stream></subpictures>'."\n";
			close($fp);
			}
		my $aspect = 2;
		$aspect = 1 if $settings->{'aspect'}->{'value'} =~ /1:1/;
		$aspect = 2 if $settings->{'aspect'}->{'value'} =~ /4:3/;
		$aspect = 3 if $settings->{'aspect'}->{'value'} =~ /16:9/;
		$aspect = 4 if $settings->{'aspect'}->{'value'} =~ /2.21:1/;
		my $cmd = $main::cmdsUsed{convert}.' "'.$dest.'/menu-bg.png" pnm:- | '
				   .$main::cmdsUsed{ppmtoy4m}.' -S 420mpeg2 -n 1 -F25:1 -A 59:54 -I t -L -r -v 0 | '
				   .$main::cmdsUsed{mpeg2enc}.' -q 2 -a '.$aspect.' -n p -f 8 -v 2 -o "'.$dest.'/menu.m2v" && '
					.$main::cmdsUsed{mplex}.' -f 8 -vbr -v 1 -o /dev/stdout "'.$dest.'/menu.m2v" "'
					.$v2icfg::config.'/menu-silence.mp2" | '
					.$main::cmdsUsed{spumux}.' -v 2 "'.$dest.'/menu.xml" > "'.$dest.'/menu.mpg"';
		print("command: <|$cmd|>\n");
		system($cmd) if not $main::testOnly;
		$i++;
		print("\n");
		}
	if(open($fp, '> '.$work.'/menu-main.png')){
		binmode($fp);
		print($fp $imgMain->png);
		close($fp);
		}
	if(open($fp, '> '.$work.'/menu-main-buttons.png')){
		binmode($fp);
		print($fp $imgMBt->png);
		close($fp);
		}
	if(open($fp, '> '.$work.'/menu-main-no-buttons.png')){
		binmode($fp);
		print($fp $imgEmpty->png);
		close($fp);
		}
	if(not $main::testOnly and open($fp, '> '.$work.'/menu-main.xml')){
		print $fp '<subpictures><stream><spu force="yes" start="00:00:00.00"'."\n";
		print $fp 'image="'.$work.'/menu-main-no-buttons.png"'."\n";
		print $fp 'select="'.$work.'/menu-main-no-buttons.png"'."\n";
		print $fp 'highlight="'.$work.'/menu-main-buttons.png" autooutline="infer" outlinewidth="5"'."\n";
		print $fp 'autoorder="rows"/></stream></subpictures>'."\n";
		close($fp);
		}
	my $aspect = 2;
	$aspect = 1 if $settings->{'aspect'}->{'value'} =~ /1:1/;
	$aspect = 2 if $settings->{'aspect'}->{'value'} =~ /4:3/;
	$aspect = 3 if $settings->{'aspect'}->{'value'} =~ /16:9/;
	$aspect = 4 if $settings->{'aspect'}->{'value'} =~ /2.21:1/;
	my $cmd = $main::cmdsUsed{convert}.' "'.$work.'/menu-main.png" pnm:- | '
			   .$main::cmdsUsed{ppmtoy4m}.' -S 420mpeg2 -n 1 -F25:1 -A 59:54 -I t -L -r -v 0 | '
			   .$main::cmdsUsed{mpeg2enc}.' -q 2 -a '.$aspect.' -n p -f 8 -v 2 -o "'.$work.'/menu-bg.m2v" && '
				.$main::cmdsUsed{mplex}.' -f 8 -vbr -v 1 -o /dev/stdout "'.$work.'/menu-bg.m2v" "'
				.$v2icfg::config.'/menu-silence.mp2" | '
				.$main::cmdsUsed{spumux}.' -v 2 "'.$work.'/menu-main.xml" > "'.$work.'/menu-bg.mpg"';
	print("command: <|$cmd|>\n");
	system($cmd) if not $main::testOnly;
	print("\n");
}

END {}

1;
