##############################################################################
#
# Config section for vdr2iso.pl and jobedit.pl
# 
##############################################################################
#    please ONLY edit the values from the <<User Config Data Section>>       #
##############################################################################
package	v2icfg;
use strict;

BEGIN {
	use	Exporter ();
	our ($VERSION, @ISA, @EXPORT, @EXPORT_OK, %EXPORT_TAGS);
	$VERSION     = "&vdr2iso-version;";
	@ISA         = qw(Exporter);
	@EXPORT      = qw($imp $work $iso $niceLevel $debug $appLang $fnColors $abortOnCutmarkNotFound
	 %colorTable %cmdsUsed %appText
	 @colors);
	%EXPORT_TAGS = ( );
	@EXPORT_OK   = qw();
}

our %cmdsUsed;
our %colorTable;
our @colors;

##############################################################################
####                User Config Data Section starts here                  ####
##############################################################################
our $imp  = '/video0';					# the root of all recordings like  ( /video0 )
our $work = '/video0/.vdrburn';		# where to put all temporary stuff ( /video0/.vdrburn )
our $iso  = '/pub/export';  			# where to put the iso             ( /pub/export )

#
# default settings (some may be changed in the list-file
# 
#our $fnCutMarks		= 'marks.vdr';
our $fnCutMarks		= '';
our $abortOnCutmarkNotFound = 1;
our $cutmarkMargin   = 500000;		# on splitting records, if cutmark is found
												# inside the margin, the cutmark is used as
												# splitpoint. 		
our $config          = '/etc/vdr/plugins/burn';
our $fntBig          = $config.'/eklektcn.ttf';
our $fntStd          = $config.'/helmetr.ttf';
our $fnColors        = '/usr/X11R6/lib/X11/rgb.txt';
our $deMuxer         = 'projectX';	# projectX OR vdrsync
our $chapterLength   = 5;				# minutes
our $bgImage         = '/XChange/jag_cast_main2.png';
our $colBackground   = '0x001E64';
our $colForeground   = 'white';
our $colShadow       = 'lightskyblue';
our $defAspect       = '4:3';
our $defLang         = '2';
our $niceLevel       = 19;
our $debug           = 0;

#
# commands used on conversion
#
$cmdsUsed{vdrsync}   = '/usr/bin/vdrsync.pl';
$cmdsUsed{java}      = '/opt/blackdown-jdk-1.4.2.02/bin/java';
$cmdsUsed{projectX}  = '/usr/local/src/ProjectX/ProjectX.jar';
$cmdsUsed{mplex}     = '/usr/bin/mplex';
$cmdsUsed{convert}   = '/usr/bin/convert';
$cmdsUsed{png2yuv}   = '/usr/bin/png2yuv';
$cmdsUsed{ppmtoy4m}  = '/usr/bin/ppmtoy4m';
$cmdsUsed{mpeg2enc}  = '/usr/bin/mpeg2enc';
$cmdsUsed{spumux}    = '/usr/bin/spumux';
$cmdsUsed{dvdauthor} = '/usr/bin/dvdauthor';
$cmdsUsed{genindex}  = '/usr/bin/genindex';
$cmdsUsed{mkisofs}   = '/usr/bin/mkisofs';		  

#
# Texts used in the menues (dvd-menu and jobeditor)
# 
our $appLang = 'de';
our %appText = {de=>{}};

$appText{en} = {
aspect=>'aspect',
back=>'back',
cancel=>'Cancel',
chapLen=>'chapter length',
clone=>'Clone',
colBack=>'background color',
colFront=>'foreground color',
colShadow=>'shadow color',
colorSelection=>'color selection',
cutmarkat=>'cutmark at',
cutmarks=>'cutmarks-file',
defheader=>'cinema',
demux=>'demuxer',
description=>'description',
disks=>'defined disks',
done=>'Done',
estimated=>'estimated size on dvd: ',
exit=>'Exit',
fntBig=>'header font',
fntStd=>'standard font',
globals=>'global defaults',
gonnascan=>'Scanning recordings... Please be patient :)',
header=>'header',
hintaddrec=>'The shown aspect and audio-format may be wrong, depending on the vdrsync-version.'."\n" 
		  	  .'Start projectX for selected recording to check it visually.'."\n\n" 
			  .'The size-information is a precalculation upon filesize, cutmarks and the ' 
			  .'preferred audio-track with the aimed target beeing DVD (any size of 0 is ' 
			  .'a hint that the cutmarks may not be ok)'."\n\n" 
			  .'The splitting of a recording is for the big ones (for those who don\'t want ' 
			  .'to use requant).',
hintsplit=>'The file containing the splitmark will be part of both recordings.'."\n" 
		  	 .'The cutmarks will be changed to fit the new recordings.'."\n"
			 .'You may use projectX to check it.'."\n" 
			 .'The new created recording will have a timestamp 5 minutes later than the original.',
imgBack=>'background image',
language=>'language',
mbtitle=>'change of %s',
newdisk=>'Add disk',
newrec=>'Add recording',
no=>'No',
nocache=>'cachefile does not exist.',
nospace=>'not enough space left for conversion job!',
ok=>'Ok',
path=>'path',
playMovie=>'play movie',
preview=>'Preview',
projectx=>'start projectX',
qupdate=>'%s has changed.'."\n".'Use new value for all recordings?'."\n",
recording=>'recording settings',
recordings=>'recordings of disk',
rescan=>'wipe cache',
save=>'Save',
split=>'split recording',
summary=>'summary of recording',
title=>'title',
totalsize=>'total size of files: ',
yes=>'Yes'
};

$appText{de} = {
aspect=>'Seitenverhltnis',
back=>'Zurck',
cancel=>'Abbruch',
chapLen=>'Kapitellnge',
clone=>'Eintrag klonen',
colBack=>'Hintergrundfarbe',
colFront=>'Vordergrundfarbe',
colShadow=>'Schattenfarbe',
colorSelection=>'Farbauswahl',
cutmarkat=>'Schnittmarke bei',
cutmarks=>'Schnittmarken',
defheader=>'Kino',
demux=>'Demuxer',
description=>'Filmbeschreibung',
disks=>'Scheibenwelten',
done=>'Fertig',
estimated=>'fertige Filmgre (geschtzt): ',
exit=>'Beenden',
fntBig=>'Font f. berschrift',
fntStd=>'Standard-Font',
globals=>'sytemweite Vorgabewerte',
gonnascan=>'Die Aufnahme-Informationen werden eingelesen... Das kann etwas dauern :)', 			
header=>'berschrift',
hintaddrec=>'je nach vdrsync-Version kann das Format (Bild und Ton) fehlerhaft sein.'."\n" 
		     .'Zur berprfung kann ProjektX gestartet werden. '."\n\n" 
			  .'Die Grenangabe ist eine Vorkalkulation aus Gesamtgre, Schnittmarken und '
			  .'Tonspur bezogen auf die Ausgabe auf DVD (Gre 0 knnte ein Zeichen fr ' 
			  .'fehlerhafte Schnittmarken sein.'."\n\n"
			  .'Das Trennen einer Aufnahme dient dazu, Aufnahmen, die zu gro sind in 2 Teile ' 
			  .'zu teilen (Fr diejenigen, die kein requant verwenden mchten).',
hintsplit=>'Die Trennung erfolgt in ganzen Dateien, d.h. die Datei, in der der Trennpunkt ' 
			 .'liegt, gehrt nach der Teilung zu beiden Aufnahmen. Die Schnittmarken-Dateien '
			 .'werden so angepasst, dass der Schnitt an der gewnschten Trennmarke stattfindet.'."\n"
			 .'Falls keine Schnittmarkendatei gefunden wurde, wird fr beide Aufnahmen eine '
			 .'neue erstellt. '."\n" 
			 .'Die neu erzeugte Teilaufnahme liegt im Zeitstempel 5 Minuten weiter.',
imgBack=>'Bild fr Hintergrund',
language=>'Sprachindex',
mbtitle=>'Neuer Wert bei %s',
newdisk=>'neue Zusammenstellung',
newrec=>'Aufnahmen zuordnen',
no=>'Nein',
nocache=>'Cache-Datei nicht gefunden.',
nospace=>'Es ist nicht gengend Platz fr die Umwandlung vorhanden.',			
ok=>'Ok',
path=>'Pfad',
playMovie=>'Film abspielen',
preview=>'Vorschau',
projectx=>'ProjektX starten',
qupdate=>'%s wurde gendert.'."\n".'Soll der neue Wert fr alle Aufnahmen gelten?',
recording=>'Einstellungen fuer Aufnahme',
recordings=>'zugeordnete Aufnahmen fuer DVD',
rescan=>'Cache leeren',			
save=>'Speichern',
split=>'Aufnahme trennen',
summary=>'Beschreibung der Aufnahme',
title=>'Titel',
totalsize=>'Gesamtgre der Dateien: ',
yes=>'Ja'
};

##############################################################################
####                  User Config Data Section ends here                  ####
##############################################################################
#
END {}
1
